/****  DISPIO.H

       Header file for DISPIO.H
       Built by A. Warnock, ST Systems Corp., NASA/GSFC 5/90

****/

/* * * *  Defined Constants * * * */

#define CGA       0
#define EGA350    1
#define PGA       2
#define VGA480    3
#define VGA200    4
#define BIOS      5
#define ORCHID480 6
#define ORCHID600 7
#define EVGA640   8
#define EVGA512   9
#define EVGA800  10
#define EGA480   11
#define ATI640   12
#define ATI800   13
#define ATI1024  14
#define PARADISE 15
#define ORCHID768   16

/* * * *  External Function Prototypes * * * */

extern int DisplayOn (void);
extern int DisplayOff (void);
extern int ReadPalette (struct Color *);
extern int WritePalette (struct Color *);
extern int WritePixel (int, int, int);
extern int ReadPixel (int, int, int *);
extern int DisplayLine (unsigned char *,int ,int ,int );
extern int FormatLine (unsigned char *buffer, int nsdd, int nsd, int bitshift, int NoScale, char status[]);
extern int ClearDisplay (int );

/* * * *  External Global Variables * * * */

extern char     specname[8];
extern int      DisplayDevice, dispnl, dispns, numDN, numshades, OneScreen;

/* DisplayDevice indicates the type of display (CGA=0, EGA=1, PGA=2).
   dispnl        is the number of lines in the display.
   dispns        is the number of samples in the display.
   numDN         is the number of unique pixel values (e.g. 4 bits ->
                 numDN=16).
   numshades     is the number of shades each of red, green, and blue
                 (e.g.  numshades=16 gives 16**3 = 4096 possible colors).
   OneScreen     is true if there is only one screen, i.e. there is not
                 image screen and a text screen.
*/

extern struct   Color
/*
   This is the structure for the color palette.
   The current palette is stored in PaletteTable.
*/
         {
                unsigned char  r, g, b;
         } DefaultPalette[256], PaletteTable[256];
